package org.dromara.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.dromara.domain.SenMonitorPointMedia;
import org.dromara.domain.SenMonitorTaskAlgorithms;
import org.dromara.domain.vo.SenMonitorPointMediaVo;
import org.dromara.mapper.SenMonitorPointMediaMapper;
import org.dromara.mapper.SenMonitorTaskAlgorithmsMapper;
import org.springframework.stereotype.Service;
import org.dromara.domain.bo.SenMonitorTaskBo;
import org.dromara.domain.vo.SenMonitorTaskVo;
import org.dromara.domain.SenMonitorTask;
import org.dromara.mapper.SenMonitorTaskMapper;
import org.dromara.service.ISenMonitorTaskService;

import java.util.*;

/**
 * 任务管理Service业务层处理
 *
 * @author luogang
 * @date 2024-09-19
 */
@RequiredArgsConstructor
@Service
public class SenMonitorTaskServiceImpl implements ISenMonitorTaskService {

    private final SenMonitorTaskMapper baseMapper;
    private final SenMonitorTaskAlgorithmsMapper taskAlgorithmsMapper;
    private final SenMonitorPointMediaMapper mediaMapper;

    /**
     * 查询任务管理
     *
     * @param id 主键
     * @return 任务管理
     */
    @Override
    public SenMonitorTaskVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询任务管理列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 任务管理分页列表
     */
    @Override
    public TableDataInfo<SenMonitorTaskVo> queryPageList(SenMonitorTaskBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<SenMonitorTask> lqw = buildQueryWrapper(bo);
        Page<SenMonitorTaskVo> result = baseMapper.selectVoPageWrapper(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的任务管理列表
     *
     * @param bo 查询条件
     * @return 任务管理列表
     */
    @Override
    public List<SenMonitorTaskVo> queryList(SenMonitorTaskBo bo) {
        LambdaQueryWrapper<SenMonitorTask> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<SenMonitorTask> buildQueryWrapper(SenMonitorTaskBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<SenMonitorTask> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getMediaId() != null, SenMonitorTask::getMediaId, bo.getMediaId());
        lqw.eq(bo.getPointId() != null, SenMonitorTask::getPointId, bo.getPointId());
        lqw.eq(StringUtils.isNotBlank(bo.getVideoType()), SenMonitorTask::getVideoType, bo.getVideoType());
        lqw.eq(StringUtils.isNotBlank(bo.getProgress()), SenMonitorTask::getProgress, bo.getProgress());
        lqw.eq(StringUtils.isNotBlank(bo.getStatus()), SenMonitorTask::getStatus, bo.getStatus());
        return lqw;
    }

    /**
     * 新增任务管理
     *
     * @param bo 任务管理
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(SenMonitorTaskBo bo) {
        SenMonitorTask add = MapstructUtils.convert(bo, SenMonitorTask.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改任务管理
     *
     * @param bo 任务管理
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(SenMonitorTaskBo bo) {
        SenMonitorTask update = MapstructUtils.convert(bo, SenMonitorTask.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(SenMonitorTask entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除任务管理信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }

    @Override
    public Map<String, Object> getTaskInfoByPointId(Long id) {
        Map<String,Object> map = new HashMap<>();
        LambdaQueryWrapper<SenMonitorTask> lqw = Wrappers.lambdaQuery();
        lqw.eq(SenMonitorTask::getPointId, id);
         List<SenMonitorTaskVo> senMonitorTaskList = baseMapper.selectVoList(lqw);

         if(senMonitorTaskList.size()>0){
             for (SenMonitorTaskVo senMonitorTaskVo : senMonitorTaskList) {
                 map.put("videoType",senMonitorTaskVo.getVideoType());
                 LambdaQueryWrapper<SenMonitorPointMedia> media = Wrappers.lambdaQuery();
                 media.eq(SenMonitorPointMedia::getId, senMonitorTaskVo.getMediaId());
                 senMonitorTaskVo.setMediaInfo(mediaMapper.selectOne(media));
                 senMonitorTaskVo.setTaskAlgorithms(taskAlgorithmsMapper.selectTaskAlgorithms(senMonitorTaskVo.getId()));
             }
         }
        map.put("list",senMonitorTaskList);
        return map;
    }
}
